

public Plugin myinfo = 
{
	name = "Hook OnEntityDestroyed Helper",
	author = "Bacardi",
	description = "Core plugin to handle HookOnEntityDestroyed callback",
	version = "0.2",
	url = "https://forums.alliedmods.net/showthread.php?t=339209"
};


#include <sdkhooks>

PrivateForward HookOnEntityDestroyedForward;

ArrayList EntRefs;

public void OnPluginStart()
{
	HookOnEntityDestroyedForward = new PrivateForward(ET_Ignore, Param_Cell, Param_Any);
}

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	RegPluginLibrary("hookonentitydestroyed");
	CreateNative("HookOnEntityDestroyed", __HookOnEntityDestroyed);
	CreateNative("UnHookOnEntityDestroyed", __UnHookOnEntityDestroyed);
	return APLRes_Success;
}

public void OnNotifyPluginUnloaded(Handle plugin)
{
	HookOnEntityDestroyedForward.RemoveAllFunctions(plugin);

	if(EntRefs == null)
		return;

	int len = EntRefs.Length;

	DataPack pack;
	Handle plug;

	for(int x = 0; x < len; x++)
	{
		pack = view_as<DataPack>(EntRefs.Get(x));

		pack.Position = view_as<DataPackPos>(1);
		plug = pack.ReadCell();

		if(plug != plugin)
			continue;

		delete pack;

		//PrintToServer("Erase plugin %X index %i", plugin, EntRefs.Erase(x--));

		EntRefs.Erase(x--);
		len--;
	}
}



public any __HookOnEntityDestroyed(Handle plugin, int numParams)
{
	return HookEntityDestroyed(plugin);
}

public any __UnHookOnEntityDestroyed(Handle plugin, int numParams)
{
	return HookEntityDestroyed(plugin, true);
}

static bool HookEntityDestroyed(Handle plugin, bool UnHook = false)
{
	if(EntRefs == null)
		EntRefs = new ArrayList();

	int len = EntRefs.Length;

	int EntRef = GetNativeCell(1);
	int cmp;

	DataPack pack;
	Handle plug;

	for(int x = 0; x < len; x++)
	{
		pack = view_as<DataPack>(EntRefs.Get(x));

		pack.Position = view_as<DataPackPos>(0);
		cmp = pack.ReadCell();
		plug = pack.ReadCell();


		if(!UnHook && cmp == EntRef && plug == plugin)
			return false;

		if(UnHook && cmp == EntRef && plug == plugin)
		{
			pack.Position = view_as<DataPackPos>(2);

			HookOnEntityDestroyedForward.RemoveFunction(plugin, pack.ReadFunction());

			delete pack;

			//PrintToServer("Erase plugin %X index %i", plugin, EntRefs.Erase(x--));

			EntRefs.Erase(x);

			return true;
		}
	}

	if(UnHook)
		return false;

	pack = new DataPack();
	pack.WriteCell(EntRef);
	pack.WriteCell(plugin);
	pack.WriteFunction(GetNativeFunction(2));
	pack.WriteCell(GetNativeCell(3));
	pack.Reset();

	EntRefs.Push(pack);

	//PrintToServer("__HookOnEntityDestroyed EntRef %i plugin %X numParams %i", EntRef, plugin, numParams);

	HookOnEntityDestroyedForward.AddFunction(plugin, GetNativeFunction(2));

	return true;
}


public void OnEntityDestroyed(int entity)
{
	if(!IsValidEdict(entity) || EntRefs == null)
		return;

	int len = EntRefs.Length;

	int EntRef = EntIndexToEntRef(entity);
	int cmp;

	DataPack pack;

	for(int x = 0; x < len; x++)
	{
		pack = view_as<DataPack>(EntRefs.Get(x));

		pack.Position = view_as<DataPackPos>(0);

		cmp = pack.ReadCell();

		if(cmp == EntRef)
		{
			Handle plugin = view_as<Handle>(pack.ReadCell());

			Call_StartFunction(plugin, pack.ReadFunction());
			Call_PushCell(EntRef);
			Call_PushCell(pack.ReadCell());
			Call_Finish();

			pack.Position = view_as<DataPackPos>(2);

			HookOnEntityDestroyedForward.RemoveFunction(plugin, pack.ReadFunction());

			delete pack;

			//PrintToServer("Erase plugin %X index %i", plugin, EntRefs.Erase(x--));

			EntRefs.Erase(x--);
			len--;
			
			continue;
		}
	}
}






