

 
#if defined _hookonentitydestroyed_included
 #endinput
#endif
#define _hookonentitydestroyed_included


/**
 * Defines a HookOnEntityDestroyed Callback.
 * 
 * @param EntRef		Entity reference
 * @param data          Data passed to the HookOnEntityDestroyed native.
 */
typeset HookOnEntityDestroyedCB
{
	function void (int EntRef);
	function void (int EntRef, any data);
}

/**
 * Calls the hooked entity function when entity is destroyed.
 * Hook removes automatically when entity destroyed
 * 
 * @param EntRef		Entity reference
 * @param callback		HookOnEntityDestroyedCB function
 * @param data          Value to be passed on the invocation of the Function.
 * @return				True when entity hooked successfully.
 *						False when already hooked or failure.
 * @error				There are lot of things what could cause error
 */
native bool HookOnEntityDestroyed(int EntRef, HookOnEntityDestroyedCB callback, any data = 0);

/**
 * Unhook HookOnEntityDestroyed from entity
 * 
 * @param EntRef		Entity reference
 * @return				True when entity unhooked successfully.
 *						False when already unhooked or failure.
 * @error				There are lot of things what could cause error
 */
native bool UnHookOnEntityDestroyed(int EntRef);




/* DO NOT EDIT BELOW THIS LINE */

public SharedPlugin __pl_hookonentitydestroyed = 
{
	name = "hookonentitydestroyed",
	file = "hookonentitydestroyed.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public void __pl_hookonentitydestroyed_SetNTVOptional()
{
	MarkNativeAsOptional("HookOnEntityDestroyed");
	MarkNativeAsOptional("UnHookOnEntityDestroyed");
}
#endif
